package com.luojigou.hardware.xiaodou.ble

import android.util.Log

object XDBLEUtils {
    const val CONNECT_SUCCESS = 0
    const val CONNECTING = 1
    const val CONNECT_FAIL = 2
    const val CONNECT_NOT_FOUND = 3
    const val CONNECT_PWD_ERROR = 4

    const val END_BYTE: Byte = 255.toByte()
    fun parseConnectResponse(data: ByteArray): Int {
        if (data.size < 17) return -99
        Log.d("XDBLEUtils", "parseConnectResponse: ${data.decodeToString()}")
        return data[16] - '0'.code
    }

    fun convertToConnectRequest(ssid: String, password: String): ByteArray {
        val stringBuffer = StringBuffer()
        stringBuffer.append(Char(0x7E))
        stringBuffer.append(Char(0x01))
        stringBuffer.append(Char(ssid.length))
        ssid.toCharArray().forEach {
            stringBuffer.append(it)
        }
        stringBuffer.append(Char(password.length))
        password.toCharArray().forEach {
            stringBuffer.append(it)
        }
        val byteArray = stringBuffer.toString().toByteArray()
        return byteArrayOf(*byteArray, END_BYTE)
    }

    fun convert(): ByteArray {
        val ssid = "abcd"
        val password = "12345678"

        val stringBuffer = StringBuffer()

        stringBuffer.append(Char(0x7E))
        stringBuffer.append(Char(0x01))
        stringBuffer.append(Char(ssid.length))
        ssid.toCharArray().forEach {
            stringBuffer.append(it)
        }
        stringBuffer.append(Char(password.length))
        password.toCharArray().forEach {
            stringBuffer.append(it)
        }
        stringBuffer.append(0xFF)
        val byteArray = stringBuffer.toString().toByteArray()
        return byteArray
    }
}