package com.luojigou.hardware.xiaodou.ble

import android.annotation.SuppressLint
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.collection.ArraySet
import androidx.recyclerview.widget.RecyclerView
import com.luojigou.xiaodou.R


@SuppressLint("MissingPermission")
class XDScanBLEAdapter(
    private val itemClickListener: (com.luojigou.hardware.xiaodou.ble.XDScanBLEDevice) -> Unit,
) : RecyclerView.Adapter<XDScanBLEAdapter.ViewHolder>() {
    private val list: MutableSet<com.luojigou.hardware.xiaodou.ble.XDScanBLEDevice> = ArraySet()

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val itemView: View =
            LayoutInflater.from(parent.context).inflate(R.layout.item_ble, parent, false)
        return ViewHolder(itemView)
    }

    override fun getItemCount(): Int = list.size

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val item = list.elementAt(position)

        holder.apply {
            img.setImageResource(R.drawable.xiaodou)
            name.text = item.name
        }

        holder.itemView.setOnClickListener {
            itemClickListener(item)
        }
    }

    @SuppressLint("NotifyDataSetChanged")
    fun setValues(values: List<com.luojigou.hardware.xiaodou.ble.XDScanBLEDevice>) {
        list.clear()
        list.addAll(values)
        notifyDataSetChanged()
    }

    fun addValue(value: com.luojigou.hardware.xiaodou.ble.XDScanBLEDevice) {
        list.add(value)
        notifyItemChanged(list.size - 1)
    }

    class ViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val img = itemView.findViewById<ImageView>(R.id.iv_ble_icon)
        val name = itemView.findViewById<TextView>(R.id.tv_ble_name)
    }
}