package com.luojigou.hardware.xiaodou.ble

import android.annotation.SuppressLint
import android.bluetooth.BluetoothAdapter
import android.content.Intent
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import androidx.activity.result.ActivityResultLauncher
import androidx.activity.result.contract.ActivityResultContracts
import androidx.fragment.app.Fragment
import com.luojigou.xiaodou.R

@SuppressLint("MissingPermission")
class XDScanBLEDisableFragment(private val host: XDScanBLEStatus.Host) : Fragment() {
    private lateinit var openBle: ActivityResultLauncher<Intent>

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?
    ): View? {
        return inflater.inflate(R.layout.fragment_scanble_disable, container, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        openBle = registerForActivityResult(ActivityResultContracts.StartActivityForResult()) {
            host.onStatusChanged(XDScanBLEStatus.Disabled)
        }

        val button = view.findViewById<Button>(R.id.btn_open)
        button.setOnClickListener { checkAndOpenBle() }
    }

    private fun checkAndOpenBle() {
        openBle.launch(Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE))
    }
}