package com.luojigou.hardware.xiaodou.wifi

import android.os.Parcel
import android.os.Parcelable

data class XDScanWifiInfo(
    val ssid: String,
    val password: String,
) : Parcelable {

    companion object {
        @JvmField
        val CREATOR: Parcelable.Creator<XDScanWifiInfo> = object :
            Parcelable.Creator<XDScanWifiInfo> {
            override fun createFromParcel(source: Parcel): XDScanWifiInfo {
                return XDScanWifiInfo(
                    source.readString()!!,
                    source.readString()!!,
                )
            }

            override fun newArray(size: Int): Array<XDScanWifiInfo?> {
                return arrayOfNulls(size)
            }
        }
    }

    override fun writeToParcel(dest: Parcel, flags: Int) {
        dest.writeString(ssid)
        dest.writeString(password)
    }

    override fun describeContents(): Int {
        return 0
    }

    override fun toString(): String {
        return "XDScanWifiInfo(ssid='$ssid', password='$password')"
    }
}